/*
Anton (Liloi) Moskalenko
e-mail: liloi@mail.ru

11.06.06
17.06.06
*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream.h>
#include <stdlib.h>
#include <fstream.h>
#include <stdio.h>
#include <string.h>

using namespace std;

int cou = 16;
bool to_hex = true;

void hex_line();

bool file_hex(char *fn)
{
    hex_line();
    printf(fn);
    printf("\n\n");

    unsigned char dat;
    unsigned int pr, c = 0;
    long int in = 0, siz = 0;
    
    
    fstream fil;
    fil.open(fn,ios::in);
    
    if(!fil)
    {
        printf("\tFile unopenable!");
        return false;
    }
    
    printf("%x:\t  ",in);
    
    while(!fil.eof())
    {

        fil.read((char*)&dat,1);
        pr = dat;
        if(!fil.eof())
        {
            siz++;
            if((dat>=0)&&(dat<=15)) printf("0%X ",pr); else printf("%X ",pr);
            c++;
            if(c==::cou)
                {
                    in+=16;
                    printf("\n%x:\t  ",in);
                    c=0;
                }
        }
    }
    
    fil.close();
    
    printf("\n\n\tSize: %d (dec), %o (oct), %x (hex)",siz,siz,siz);

}



bool file_oct(char *fn)
{

    hex_line();

    printf(fn);
    printf("\n\n");

    unsigned char dat;
    unsigned int pr, c = 0;
    long int in = 0, siz = 0;
    
    
    fstream fil;
    fil.open(fn,ios::in);
    
    if(!fil)
    {
        printf("\tFile unopenable!");
        return false;
    }
    
    printf("%o:\t  ",in);
    
    while(!fil.eof())
    {
        
        fil.read((char*)&dat,1);
        pr = dat;
        if(!fil.eof())
        {
            siz++;
            if((dat>=0)&&(dat<=7)) printf("00%o ",pr); else
            if((dat>7)&&(dat<=63)) printf("0%o ",pr); 
            else printf("%o ",pr);
            
            c++;
            if(c==::cou)
                {
                    in+=16;
                    printf("\n%o:\t  ",in);
                    c=0;
                }
        }
    }
    
    fil.close();
    
    printf("\n\n\tSize: %d (dec), %o (oct), %x (hex)",siz,siz,siz);
    
}

void hex_line()
{
    for(int i=0;i<=70;i++)
    {
        printf("=");
    }
    printf("\n\n");
}

void hex_help()
{
    hex_line(); 
        printf("\tlhex [[--author\\-a][-x][-o][--help\\-h][filenames]]\n\n");
        printf("\t--author - view me :-)\n");
        printf("\t-x - to `16 (default)\n\t-o - to `8\n");
        printf("\t--help or -h - view this\n");
        printf("\t[filenames] meens fn_1.ext fn_2.ext ... fn_n.ext\n\n");
        printf("\tExample:\n\t\tlhex --author test.txt -h -o test.txt\n");
        printf("\t\tlhex -a -a --author --help -h -x -o -x test.txt test.txt :-)\n");
        printf("\t\tlhex test.txt\n\n");
}

void hex_author()
{
    hex_line();
    printf("\tAnton (Liloi) Moskalenko\n\te-mail: liloi@mail.ru\n\n");
}

void file_oh(char *fn)
{
    if(!to_hex) file_oct(fn); else file_hex(fn);
}

int main(int argc, char *argv[])
{
    
    printf("\nlHEX\nVersion 0.2a\n-=-\n\n");
    
    if(argc==1) printf("\tType `lhex -h` for help\n\n");
        
      
    if(argc>1)
    {
        for(int i = 1;i<argc;i++)
        {
            if((strcmp(argv[i],"--author")==0)||(strcmp(argv[i],"-a")==0)) hex_author(); else
            if((strcmp(argv[i],"--help")==0)||(strcmp(argv[i],"-h")==0)) hex_help(); else
            if(strcmp(argv[i],"-x")==0) to_hex = true; else
            if(strcmp(argv[i],"-o")==0) to_hex = false; else
            {
                file_oh(argv[i]);
                printf("\n\n");
            }
            
        }
    }

    return 0;
}

//
